﻿unit Execution;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,
  RunProcess, Grids, ValEdit, Math, Common
  ;

type
  TfrmExecution = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    lblTotal: TLabel;
    prgTotal: TProgressBar;
    btnCancel: TButton;
    lblStatus: TLabel;
    btnClose: TButton;
    Panel4: TPanel;
    lstStatus: TListBox;
    Label1: TLabel;
    procedure btnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure TraiteLigne(Sender: TObject);
    procedure MAJBars(Sender: TObject);
    procedure MAJStatus(Sender: TObject);
    function LigneStatus(Done, EnCours:boolean; Size1, Size2:cardinal;
      Error:string ) : string;
    procedure FormCreate(Sender: TObject);
  private
  public
    CommandLine : string;
    Files : TStringList;
    progressText1 : string;
    progressText2 : string;
    stTerminated : string;
    stExecution : string;
  end;

var
  frmExecution: TfrmExecution;
  Killed: boolean;
  Proc: TRunProcess;
  IsRunning: boolean;


implementation

{$R *.dfm}

//--------------------------------------------------------------------
procedure TfrmExecution.TraiteLigne(Sender: TObject);
var
  Line: string;
  C: char;
  k, l, S1, S2: integer;
begin
  C := lstStatus.Items[Proc.Index][1];
  Line := Trim(TStd(Sender).Line);
  if not(C in ['X', 'P']) then begin
    k := Instr(Line, '->');   
    l := Instr(Line, '<-');
    if l > 3 then k := l;
    if k > 3 then begin
      S1 := GetInteger(LeftStr(Line, k));
      Line := Trim(RightStr(Line, Length(Line) - k - 2));
      k := Instr(Line, ' ');
      S2 := GetInteger(LeftStr(Line, k));
      lstStatus.Items[Proc.Index] := LigneStatus(True, False, S1, S2, '');
    end;
    k := Instr(Line, 'error.');
    if (k > 3) or (Proc.ExitCode<>0) then begin
      lstStatus.Items[Proc.Index] := LigneStatus(True, False, 0, 0, 'Err  ');
    end;
  end;
  k := Instr(Line, 'AlreadyPackedException');
  if k > 5 then begin
    lstStatus.Items[Proc.Index] := LigneStatus(True, False, 0, 0, 'Pack ');
  end;
end;
//--------------------------------------------------------------------
procedure TfrmExecution.btnCancelClick(Sender: TObject);
begin
  Killed := True;
  Proc.Terminate;
  lblStatus.Caption := 'Compression interrompue !';
  frmExecution.Caption := 'Terminé !';
  btnCancel.Visible := False;
  btnClose.Visible := True;
end;

//--------------------------------------------------------------------
procedure TfrmExecution.btnCloseClick(Sender: TObject);
begin
  frmExecution.Close;
end;
//--------------------------------------------------------------------
function TfrmExecution.LigneStatus(Done, EnCours:boolean;
  Size1, Size2:cardinal; Error:string ) : string;
begin
  if Error='' then begin
    if EnCours then Result := '>    '
    else if Done and (Size1 > 0) and (Size2 > 0) then
      Result := StrPadLeft(IntToStr(Floor(100*Size2/Size1)), 3, ' ') + '% '
    else Result := '     ';
  end else
    Result := Error;
  Result := Result + Files[Proc.Index];
end;
//--------------------------------------------------------------------
procedure TfrmExecution.FormActivate(Sender: TObject);
var
  i: integer;
begin
  Killed := False;
  btnClose.Visible := False;
  btnCancel.Visible := True;

  frmExecution.Caption := stExecution;

  prgTotal.Position := 0;
  prgTotal.Max := Files.Count;
  lblTotal.Caption := progressText2+'(0 / '+IntToStr(Files.Count)+')';
  lblStatus.Caption := '';

  lstStatus.Clear;
  IsRunning := True;

  Proc := TRunProcess.Create;
  Proc.OnStart := MAJStatus;
  Proc.OnEnd := MAJBars;
  Proc.WindowStyle := wHide;
  Proc.Priority := tpLower;
  Proc.StdOut.Enabled := True;
  Proc.StdErr.Enabled := True;
  Proc.StdOut.OnInputLine := TraiteLigne;
  Proc.StdErr.OnInputLine := TraiteLigne;
  for i := 0 to Files.Count - 1 do begin
    Proc.Index := i;
    Proc.Commands.Add(CommandLine+' "'+Files[i]+'"');
//    Proc.Commands.Add('cscript.exe test.vbs "'+Files[i]+'"');
    lstStatus.AddItem(LigneStatus(False, False, 0, 0, ''), nil);
  end;
  Proc.Resume;
end;
//--------------------------------------------------------------------
procedure TfrmExecution.FormCreate(Sender: TObject);
begin
    progressText1 := 'Progession du fichier ';
    progressText2 := 'Progession totale ';  
    stTerminated := 'Terminé !';
    stExecution := 'Exécution';
end;
//--------------------------------------------------------------------
procedure TfrmExecution.MAJBars(Sender: TObject);
begin
  frmExecution.prgTotal.Position := frmExecution.prgTotal.Position + 1;
  frmExecution.lblTotal.Caption := progressText2+'('+
    IntToStr(frmExecution.prgTotal.Position)+' / '+IntToStr(Proc.Commands.Count)+')';
  if Proc.Index >= Proc.Commands.Count - 1 then begin
    frmExecution.lblStatus.Caption := stTerminated;
    frmExecution.Caption := stTerminated;
    frmExecution.btnClose.Visible := True;
    frmExecution.btnCancel.Visible := False;
    lstStatus.Selected[Proc.Commands.Count - 1] := False;
  end;
  IsRunning := True;
end;
//--------------------------------------------------------------------
procedure TfrmExecution.MAJStatus(Sender: TObject);
begin
  frmExecution.lblStatus.Caption := Files[Proc.Index];
  lstStatus.Items[Proc.Index] := LigneStatus(False, True, 0, 0, '');
  lstStatus.Selected[Proc.Index] := True;
end;

end.
