unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ImgList, ShellApi, FileCtrl,
  Mask, Common;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    btnQuit: TButton;
    btnLancer: TButton;
    pgSources: TPageControl;
    tabFichiers: TTabSheet;
    tabDossier: TTabSheet;
    Panel2: TPanel;
    edtDossier: TEdit;
    btnSelectDossier: TButton;
    pgOptions: TPageControl;
    tabOptions: TTabSheet;
    lstIcons: TImageList;
    Panel3: TPanel;
    panRight: TPanel;
    panLeft: TPanel;
    btnFileDelete: TButton;
    btnFileAdd: TButton;
    lstFiles: TListBox;
    chkDossierRecursif: TCheckBox;
    chkDossierDLL: TCheckBox;
    chkDossierEXE: TCheckBox;
    dlgOpenFile: TOpenDialog;
    GroupBox2: TGroupBox;
    trkLevel: TTrackBar;
    lblLevel: TLabel;
    Panel4: TPanel;
    GroupBox1: TGroupBox;
    radUncompress: TRadioButton;
    radCompress: TRadioButton;
    GroupBox3: TGroupBox;
    chkBackup: TCheckBox;
    GroupBox4: TGroupBox;
    chkOverlaySkip: TCheckBox;
    Panel5: TPanel;
    GroupBox5: TGroupBox;
    chkAllMethods: TCheckBox;
    chkAllFilters: TCheckBox;
    chkcrpms: TCheckBox;
    edtcrpms: TEdit;
    chkCompressExports: TCheckBox;
    chkCompressIcons: TCheckBox;
    chkStripRelocations: TCheckBox;
    chkDontCompressResources: TCheckBox;
    btnOptDefault: TButton;
    btnOptFast: TButton;
    Panel6: TPanel;
    btnApropos: TButton;
    Panel7: TPanel;
    btnEN: TButton;
    btnFR: TButton;
    Panel9: TPanel;
    Panel8: TPanel;
    Button1: TButton;
    Button2: TButton;
    Panel10: TPanel;
    procedure btnQuitClick(Sender: TObject);
    procedure btnSelectDossierClick(Sender: TObject);
    procedure edtDossierChange(Sender: TObject);
    procedure btnFileAddClick(Sender: TObject);
    procedure btnFileDeleteClick(Sender: TObject);
    procedure AjouteFichier(Fichier: string);
    procedure trkLevelChange(Sender: TObject);
    procedure pgOptionsResize(Sender: TObject);
    procedure edtcrpmsChange(Sender: TObject);
    procedure btnLancerClick(Sender: TObject);
    procedure btnOptDefaultClick(Sender: TObject);
    procedure btnOptFastClick(Sender: TObject);
    procedure Panel6Resize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnAproposClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnFRClick(Sender: TObject);
    procedure btnENClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    CurrentDir : string;
  public
    { Dclarations publiques }
  end;

var
  frmMain: TfrmMain;

implementation

uses Apropos, Execution;

{$R *.dfm}

//--------------------------------------------------------------------
procedure TfrmMain.btnAproposClick(Sender: TObject);
begin
  frmApropos.ShowModal;
end;
//--------------------------------------------------------------------
procedure TfrmMain.btnFileAddClick(Sender: TObject);
var
  i : integer;
begin
  if dlgOpenFile.Execute then
  begin
    for i := 0 to dlgOpenFile.Files.Count-1 do
      AjouteFichier(dlgOpenFile.Files[i]);
  end
end;

//--------------------------------------------------------------------
procedure TfrmMain.btnFileDeleteClick(Sender: TObject);
begin
  lstFiles.DeleteSelected
end;
//--------------------------------------------------------------------
procedure TfrmMain.btnENClick(Sender: TObject);
begin
  tabOptions.Caption := 'Options';
  GroupBox1.Caption := 'Mode';
  radUncompress.Caption := 'Decompress';
  radCompress.Caption := 'Compress';
  GroupBox3.Caption := 'Misc';
  chkBackup.Caption := 'Keep backup';
  chkcrpms.Caption := 'crp-ms :';
  chkcrpms.hint := 'This uses more memory to be more efficient';
  edtcrpms.hint := chkcrpms.hint;
  GroupBox4.Caption := 'Overlay';
  chkOverlaySkip.Caption := 'Don''t compress a file with overlay';
  GroupBox2.Caption := 'Compression level';
  GroupBox5.Caption := 'win32 / pe';
  chkAllMethods.Caption := 'All methods';
  chkAllFilters.Caption := 'All filters';
  chkCompressExports.Caption := 'Compress '#39'exports'#39' section';
  chkCompressIcons.Caption := 'Compress icons';
  chkStripRelocations.Caption := 'Remove '#39'relocations'#39;
  chkDontCompressResources.Caption := 'Don''t compress resources';
  btnQuit.Caption := 'Quit';
  btnLancer.Caption := 'GO';
  btnOptDefault.Caption := 'Default options';
  btnOptFast.Caption := 'High compression options';
  btnApropos.Caption := 'About';
  tabFichiers.Caption := 'Files';
  btnFileDelete.Caption := 'Delete';
  btnFileAdd.Caption := 'Add';
  tabDossier.Caption := 'Folder';
  btnSelectDossier.Caption := '...';
  chkDossierRecursif.Caption := 'Recursive scan';
  chkDossierDLL.Caption := 'Run on DLL';
  chkDossierEXE.Caption := 'Run on EXE';
  dlgOpenFile.Filter := 'All binary|*.dll;*.exe|EXE|*.exe|DLL|*.dll';
  dlgOpenFile.Title := 'Select the folder to scan';
  // Execute
  with frmExecution do begin
    btnCancel.caption := 'Cancel';
    btnClose.caption := 'Close';
    lblTotal.caption := 'Progress';
    Label1.caption := 'File list';
    progressText1 := 'File Progess ';
    progressText2 := 'Total Progression ';
    stTerminated := 'Finished !';
    stExecution := 'Execution';
  end;

end;
//--------------------------------------------------------------------
procedure TfrmMain.btnFRClick(Sender: TObject);
begin
  tabOptions.Caption := 'Options';
  GroupBox1.Caption := 'Mode';
  radUncompress.Caption := 'D'#233'compression';
  radCompress.Caption := 'Compression';
  GroupBox3.Caption := 'Divers';
  chkBackup.Caption := 'Garder une copie de sauvegarde';
  chkcrpms.Caption := 'crp-ms :';
  chkcrpms.hint := 'Cela utilise plus de m'#233'moire durant la compression pour tenter d' +
                #39'obtenir un meilleur r'#233'sultat';
  edtcrpms.hint := chkcrpms.hint;
  GroupBox4.Caption := 'Overlay';
  chkOverlaySkip.Caption := 'Ne pas compresser un fichier avec un overlay';
  GroupBox2.Caption := 'Niveau de compression';
  GroupBox5.Caption := 'win32 / pe';
  chkAllMethods.Caption := 'Toutes les m'#233'thodes';
  chkAllFilters.Caption := 'Tous les filtres';
  chkCompressExports.Caption := 'Compresse la section '#39'exports'#39;
  chkCompressIcons.Caption := 'Compresse les icones';
  chkStripRelocations.Caption := 'Enlever les '#39'relocations'#39;
  chkDontCompressResources.Caption := 'Ne pas compresser les ressources';
  btnQuit.Caption := 'Quitter';
  btnLancer.Caption := 'Lancer';
  btnOptDefault.Caption := 'Options par d'#233'faut';
  btnOptFast.Caption := 'Options de compression '#39'forte'#39;
  btnApropos.Caption := 'A Propos';        
  tabFichiers.Caption := 'Fichiers';
  btnFileDelete.Caption := 'Supprimer';
  btnFileAdd.Caption := 'Ajouter';
  tabDossier.Caption := 'Dossier';
  btnSelectDossier.Caption := '...';
  chkDossierRecursif.Caption := 'Parcourir les sous-dossiers (R'#233'cursif)';
  chkDossierDLL.Caption := 'Traiter les DLL';
  chkDossierEXE.Caption := 'Traiter les EXE';
  dlgOpenFile.Filter := 'Tous les binaires|*.dll;*.exe|EXE|*.exe|DLL|*.dll';
  dlgOpenFile.Title := 'S'#233'lectionnez le dossier '#224' traiter :';
  // Execute
  with frmExecution do begin
    btnCancel.caption := 'Annuler';
    btnClose.caption := 'Fermer';
    lblTotal.caption := 'Progression';
    Label1.caption := 'Liste d'#39'avancement';   
    progressText1 := 'Progession du fichier ';
    progressText2 := 'Progession totale '; 
    stTerminated := 'Termin !';
    stExecution := 'Excution';
  end;
end;
//--------------------------------------------------------------------
procedure TfrmMain.btnLancerClick(Sender: TObject);
var
  cmd: string;
  i: integer;
  Files: TStringList;
begin
  cmd := '"'+CurrentDir+'\upx\upx.exe"';
  if radUncompress.checked then
    cmd := cmd+' -d'
  else
  begin
    if chkOverlaySkip.checked then
      cmd := cmd+' --overlay=skip';
    if chkBackup.checked then
      cmd := cmd+' --backup';
    if chkcrpms.checked then
      cmd := cmd+' --crp-ms='+edtcrpms.Text;
    if trkLevel.position = 10 then
      cmd := cmd+' --best'
    else
      cmd := cmd+' -'+IntToStr(trkLevel.position);
    if chkCompressExports.checked then
      cmd := cmd+' --compress-exports=1'
    else
      cmd := cmd+' --compress-exports=0';
    if chkCompressIcons.checked then
      cmd := cmd+' --compress-icons=2'
    else
      cmd := cmd+' --compress-icons=0';     
    if chkStripRelocations.checked then
      cmd := cmd+' --strip-relocs=1'
    else
      cmd := cmd+' --strip-relocs=0';    
    if chkAllFilters.checked then
      cmd := cmd+' --all-filters';
    if chkAllMethods.checked then
      cmd := cmd+' --all-methods';
    if chkDontCompressResources.checked then
      cmd := cmd+' --compress-resources=0';
  end;
  frmExecution.CommandLine := cmd;
  frmExecution.Files := TStringList.Create;

  case pgSources.ActivePageIndex of
    0: begin
      if lstFiles.Items.Count > 0 then
        begin
//          SetLength(frmExecution.Files, lstFiles.Items.Count);
          for i := 0 to lstFiles.Items.Count - 1 do
            frmExecution.Files.Add(lstFiles.Items[i]);
          frmExecution.ShowModal;
        end
      else
        MessageBox(
          handle,
          'Slectionnez au moins 1 fichier ...',
          'Erreur',
          MB_OK);
    end;
    1: begin
      if DirectoryExists(edtDossier.Text) then
        begin
          if chkDossierEXE.Checked or chkDossierDLL.Checked then
            begin
              Files := TStringList.Create;
              if chkDossierEXE.Checked then
                SearchFiles(edtDossier.Text, 'exe', true, Files);  
              if chkDossierDLL.Checked then
                SearchFiles(edtDossier.Text, 'dll', true, Files);
//              SetLength(frmExecution.Files, Files.Count);
              if Files.Count <= 0 then begin
                MessageBox(
                  handle,
                  'Il n''y a aucun fichier EXE et/ou DLL',
                  'Erreur',
                  MB_OK);
                Files.Free
              end else begin
                for i := 0 to Files.Count - 1 do
                  frmExecution.Files.Add(Files[i]);
                Files.Free;
                frmExecution.ShowModal;
              end;
            end
          else
            MessageBox(
              handle,
              'Slectionnez au moins 1 type de fichier : EXE et/ou DLL',
              'Erreur',
              MB_OK);
        end
      else
        MessageBox(
          handle,
          'Le dossier n''existe pas',
          'Erreur',
          MB_OK);
    end;
  end;
end;

//--------------------------------------------------------------------
procedure TfrmMain.btnOptDefaultClick(Sender: TObject);
begin                 
  chkOverlaySkip.Checked := False;
  chkcrpms.Checked := False;
  trkLevel.Position := 8;
  chkCompressExports.Checked := True;
  chkCompressIcons.Checked := True;
  chkStripRelocations.Checked := True;
  chkAllFilters.Checked := False;
  chkAllMethods.Checked := False;
  chkDontCompressResources.Checked := False;
end;

//--------------------------------------------------------------------
procedure TfrmMain.btnOptFastClick(Sender: TObject);
begin                      
  chkOverlaySkip.Checked := False;
  chkcrpms.Checked := True;
  edtcrpms.Text := '999999';
  trkLevel.Position := 10;
  chkCompressExports.Checked := True;
  chkCompressIcons.Checked := True;
  chkStripRelocations.Checked := True;
  chkAllFilters.Checked := True;
  chkAllMethods.Checked := True;
  chkDontCompressResources.Checked := False;
end;

//--------------------------------------------------------------------
procedure TfrmMain.btnQuitClick(Sender: TObject);
begin
  frmMain.Close;
end;

//--------------------------------------------------------------------
procedure TfrmMain.btnSelectDossierClick(Sender: TObject);
var
  dir: string;
begin
  dir := edtDossier.Text;
  if SelectDirectory('', '', dir) then
    edtDossier.Text := dir;
end;

//--------------------------------------------------------------------
procedure TfrmMain.edtcrpmsChange(Sender: TObject);
var
  n : integer;
begin
  n := GetInteger(Trim(edtcrpms.Text));
  if n < 10000 then
    edtcrpms.Text := '10000'
  else if n > 999999 then
    edtcrpms.Text := '999999'
  else
    if IntToStr(n) <> edtcrpms.Text then
      edtcrpms.Text := IntToStr(n);
end;

//--------------------------------------------------------------------
procedure TfrmMain.edtDossierChange(Sender: TObject);
begin
  if DirectoryExists(edtDossier.Text) then
    edtDossier.Font.Color := clWindowText
  else
    edtDossier.Font.Color := clRed;
end;

//--------------------------------------------------------------------
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// faire le kill des sous process si besoin

end;
//--------------------------------------------------------------------
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  CurrentDir := GetBinDir;
  btnOptDefaultClick(Self);
end;
//--------------------------------------------------------------------
procedure TfrmMain.FormShow(Sender: TObject);
begin
  case GetLanguageIndex of
    LANG_FRENCH : btnFRClick(Self);
    else btnENClick(Self);
  end;
end;
//--------------------------------------------------------------------
procedure TfrmMain.Panel6Resize(Sender: TObject);
begin
  btnApropos.Left := Trunc((Panel6.width-btnApropos.width)/2);
end;

//--------------------------------------------------------------------
procedure TfrmMain.pgOptionsResize(Sender: TObject);
begin
  Panel4.width := Trunc(tabOptions.width/2);
end;

//--------------------------------------------------------------------
procedure TfrmMain.trkLevelChange(Sender: TObject);
begin
  if trkLevel.position = 10 then
    lblLevel.Caption:= 'best'
  else
    lblLevel.Caption:= IntToStr(trkLevel.position);
end;

//--------------------------------------------------------------------
procedure TfrmMain.AjouteFichier(Fichier: string);
var
  i : integer;
  trouve : boolean;
begin
  trouve := false;
  for i := 0 to lstFiles.Count - 1 do
    if lstFiles.Items[i] = Fichier then
      trouve := true;
  if not(trouve) then
    lstFiles.AddItem(Fichier, nil);
end;

end.
