!include "..\Common.nsh"

;-----------------------------------------------------------------------
; MAIN SCRIPT

SetCompressor /SOLID lzma

!include "MUI.nsh"

Name "Arnapou UPX GUI"
OutFile "UPXGUI_v1.1.exe"

InstallDir "$PROGRAMFILES\Arnapou\UPX GUI"
InstallDirRegKey HKCU "Software\Arnapou\UPX GUI" ""

!define MUI_ABORTWARNING

;!insertmacro MUI_PAGE_LICENSE "licence.txt"
;!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

!insertmacro MUI_LANGUAGE "French"

InstType "Defaut"

Section "Program" Sec_Program
	SectionIn 1 RO
	SetOutPath $INSTDIR 
	File "UPXGUI.exe"
	File /r "upx"
	SetShellVarContext current
	CreateDirectory "$SMPROGRAMS\Arnapou"
	CreateDirectory "$SMPROGRAMS\Arnapou\UPX GUI"
	CreateShortCut "$SMPROGRAMS\Arnapou\UPX GUI\UPX GUI.lnk" "$INSTDIR\UPXGUI.exe"
	CreateShortCut "$SMPROGRAMS\Arnapou\UPX GUI\Uninstall.lnk" "$INSTDIR\uninstall.exe"
	WriteUninstaller "$INSTDIR\uninstall.exe"
	WriteRegStr HKCU "Software\Arnapou\UPX GUI" "" '"$INSTDIR"'
	!insertmacro AddRemovePanel_ADD "Arnapou / UPX GUI" "1.1" "992" "$INSTDIR\uninstall.exe"
SectionEnd 

UninstallText "Do you want to remove Arnapou UPX GUI of your system ?"

Section "Uninstall" Sec_Uninstall
	SetOutPath $TEMP
	SetShellVarContext current
	RMDir /r /REBOOTOK "$INSTDIR"
	RMDir /r /REBOOTOK "$SMPROGRAMS\UPX GUI"
	!insertmacro AddRemovePanel_REMOVE "Arnapou / UPX GUI"
SectionEnd 
